/***********************************************
 Version of project: 1.0 Release
************************************************
 Main.cpp -  
    4-10
 :  , -30,  ''
 Version 0.55 beta
 Last update: 30.05.2001
************************************************/
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include <math.h>
#include "Main.h"
#include "About.h"
//---------------------------------------------------------------------------
#pragma link "CSPIN"
#pragma resource "*.dfm"
TForm1 *Form1;

void MinMax(double &fymin,double &fymax,double fxmin,double fxmax,double fStepX,unsigned int fk);
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
double f (double fx, unsigned int fk)
{
   // ,  
   const
     int gran1 = 0;
     int gran2 = 1;

   //  
   if (fx < gran1) {
     for (unsigned int i = 1; i < fk; i++)
       fx *= fx;
     double rez = sin(fx);
     for (unsigned int i = 1; i < fk ; i++)
       rez += rez;
     return rez;
   }
   else if (fx >= gran1 && fx <= gran2) {
     for (unsigned int i = 1; i < fk; i++)
       fx *= fx;
     return fx;
   }
   else
     return exp(fk*fx-fk);
}
//---------------------------------------------------------------------------
void MinMax(double &fymin,double &fymax,double fxmin,double fxmax,double fStepX,unsigned int fk)
{
   fymin = f(fxmin,fk);
   fymax = f(fxmax,fk);
   double y;
   double i = fxmin;
   while (i <= fxmax) {
     y = f(i,fk);
     if (y < fymin)
       fymin = y;
     if (y > fymax)
       fymax = y;
     i += fStepX;
   }
   Form1->Label4->Caption = fymin;
   Form1->Label5->Caption = fymax;
}
//---------------------------------------------------------------------------
void Graph()
{
   double xmin;
   double xmax;
   try {
     xmin = StrToFloat(Form1->edMin->Text);
     xmax = StrToFloat(Form1->edMax->Text);
   } catch(...)
   {
       Application->MessageBox("  !", "!", MB_ICONSTOP);
   }
   if (xmax < xmin) {
     double temp;
     temp = xmax;
     xmax = xmin;
     xmin = temp;
     Form1->edMin->Text = xmin;
     Form1->edMax->Text = xmax;
     Application->MessageBox("    !   .", "!", MB_ICONWARNING);
   }
   if (xmin == xmax) {
     xmax += 1;
     Form1->edMax->Text = xmax;
     Application->MessageBox("    !   .", "!", MB_ICONWARNING);
   }
   int k = Form1->csK->Value;
   if (k < 1){
     k = 1;
     Form1->csK->Value = k;
     Application->MessageBox("    k!   .", "!", MB_ICONWARNING);
   }
   const int otstupX1 = 30;
   const int otstupX2 = 20;
   const int otstupY = 30;
   const int kol_lin = 10;
   const double dlinaValX = xmax - xmin;
   const double dlinaPixX = Form1->Image1->Width - otstupX1 - otstupX2;
   const double dlinaPixY = Form1->Image1->Height - otstupY;
   const double KofX = dlinaValX/dlinaPixX;
   double x,y,xp,yp;

   //  Image
   Form1->Image1->Canvas->Brush->Style = bsSolid;
   Form1->Image1->Canvas->Brush->Color = clWhite;
   Form1->Image1->Canvas->FillRect(Form1->Image1->ClientRect);

   //  ymax  ymin
   double ymin,ymax;
   MinMax(ymin,ymax,xmin,xmax,KofX,k);
   const double dlinaValY = ymax - ymin;
   const double KofY = dlinaPixY/dlinaValY;

   // --  ,  --
   Form1->Image1->Canvas->Pen->Width = 1;
   Form1->Image1->Canvas->Pen->Style = psDash;
   Form1->Image1->Canvas->Pen->Color = clLtGray;

   double StepPixX = dlinaPixX/kol_lin;
   double StepPixY = dlinaPixY/kol_lin;
   double StepValX = dlinaValX/kol_lin;
   double StepValY = dlinaValY/kol_lin;
   Form1->Label6->Caption = StepValX;
   Form1->Label11->Caption = StepValY;

   //  
   for (int i = 0; i < kol_lin + 2; i++) {
     xp = otstupX1 + StepPixX*i;
     Form1->Image1->Canvas->MoveTo(xp,0);
     Form1->Image1->Canvas->LineTo(xp,dlinaPixY);
     AnsiString s = FloatToStrF(xmin + StepValX*i,ffFixed,3,1);
     Form1->Image1->Canvas->TextOutA(xp,dlinaPixY + 10,s);
   }

   //  
   for (int i = 0; i < kol_lin + 1; i++) {
     Form1->Image1->Canvas->MoveTo(otstupY,StepPixY*i);
     Form1->Image1->Canvas->LineTo(Form1->Image1->Width,StepPixY*i);
     AnsiString s = FloatToStrF(ymax - StepValY*i,ffFixed,3,1);
     Form1->Image1->Canvas->TextOutA(5,StepPixY*i,s);
   }

   // --  --
   Form1->Image1->Canvas->Pen->Width = 1;
   Form1->Image1->Canvas->Pen->Style = psSolid;
   Form1->Image1->Canvas->Pen->Color = clBlue;

   //  X
   yp = dlinaPixY - (-ymin)*KofY;
   if (ymin < 0) {
          //  
     Form1->Image1->Canvas->MoveTo(otstupX1,yp);
     Form1->Image1->Canvas->LineTo(Form1->Image1->Width,yp);
          // 
     if (xmax > 0) {
       Form1->Image1->Canvas->MoveTo(Form1->Image1->Width,yp);
       Form1->Image1->Canvas->LineTo(Form1->Image1->Width - 10,yp - 5);
       Form1->Image1->Canvas->MoveTo(Form1->Image1->Width,yp);
       Form1->Image1->Canvas->LineTo(Form1->Image1->Width - 10,yp + 5);
       Form1->Image1->Canvas->TextOutA(Form1->Image1->Width - 10,yp + 7,"X");
     }
   }

   //  Y
   xp = -xmin/KofX;
   if (xmin < 0) {
       //  
     Form1->Image1->Canvas->MoveTo(xp + otstupX1,0);
     Form1->Image1->Canvas->LineTo(xp + otstupX1,dlinaPixY);
       // 
     if (ymax > 0) {
       Form1->Image1->Canvas->MoveTo(xp + otstupX1,0);
       Form1->Image1->Canvas->LineTo(xp + otstupX1 - 5,10);
       Form1->Image1->Canvas->MoveTo(xp + otstupX1,0);
       Form1->Image1->Canvas->LineTo(xp + otstupX1 + 5,10);
       Form1->Image1->Canvas->TextOutA(xp + otstupX1 - 12,0,"Y");
     }
   }

   //  
   y = f(xmin,k);
   yp = dlinaPixY - (y - ymin)*KofY;
   Form1->Image1->Canvas->MoveTo(otstupX1,yp);

   Form1->Image1->Canvas->Pen->Width = 2;
   Form1->Image1->Canvas->Pen->Style = psSolid;
   Form1->Image1->Canvas->Pen->Color = clBlack;

   // --  --
   for(xp = 0; xp <= dlinaPixX; xp++) {
     x = xmin + xp * KofX;
     y = f(x,k);
     yp = dlinaPixY - (y - ymin)*KofY;
     Form1->Image1->Canvas->LineTo(xp + otstupX1,yp);
   }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::sbDrawClick(TObject *Sender)
{
   Graph();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::sbSaveClick(TObject *Sender)
{
   if (SavePictureDialog1->Execute()) {
     try {
       Image1->Picture->Bitmap->SaveToFile(SavePictureDialog1->FileName);
     }
     catch(...) {
       Application->MessageBox("   !", "!", MB_ICONSTOP);
     }
   }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::sbQuitClick(TObject *Sender)
{
   Close();
}
//---------------------------------------------------------------------------


void __fastcall TForm1::AboutClick(TObject *Sender)
{
   Application->CreateForm(__classid(TfmAbout), &fmAbout);
   fmAbout->ShowModal();
}
//---------------------------------------------------------------------------
